<template>
  <v-app id="app">
    <div ref="navbarweb" v-if="!isMobile">
      <Menu :selectedMenuItem="selectedMenuItem" />
    </div>
    <div v-else>
      <MenuMobile
        :selectedMenuItem="selectedMenuItem"
        @scroll-to-ref="scrollToTargetAdjusted"
      />
    </div>
    <div v-if="!isMobile" class="wrapper">
      <MainPage
        @change-menu-item="changeMenuItem"
        :selectedMenuItem="selectedMenuItem"
      />
    </div>
    <div v-else>
      <MainPageMobile
        ref="mobilemain"
        @change-menu-item="changeMenuItem"
        :selectedMenuItem="selectedMenuItem"
        @scroll-to-ref="scrollToTargetAdjusted"
      />
    </div>
    <Footer id="contact" ref="contact" @switch-locale="switchLocale" />
  </v-app>
</template>

<script>
import Footer from "../components/Footer.vue";
import Menu from "../components/desktop/Menu.vue";
import MenuMobile from "../components/mobile/MenuMobile.vue";
import MainPage from "../components/desktop/MainPage.vue";
import MainPageMobile from "../components/mobile/MainPageMobile.vue";

export default {
  title: "Main",

  components: {
    Menu,
    MainPage,
    MainPageMobile,
    MenuMobile,
    Footer,
  },
  data: () => ({
    isMobile: false,
    selectedMenuItem: 0,
  }),
  mounted() {
    this.onResize();
    window.addEventListener("resize", this.onResize, { passive: true });
    document.title = "Save food and money with Robin Food";
  },
  methods: {
    switchLocale(locale) {
      if (this.$i18n.locale !== locale) {
        this.$i18n.locale = locale;
        localStorage.setItem("language", locale);
      }
    },
    onResize() {
      this.isMobile = window.innerWidth < 600;
    },
    changeMenuItem(item) {
      this.selectedMenuItem = item;
    },
    getCoords(elem) {
      var box = elem.getBoundingClientRect();

      var body = document.body;
      var docEl = document.documentElement;

      var scrollTop = window.pageYOffset || docEl.scrollTop || body.scrollTop;
      var scrollLeft =
        window.pageXOffset || docEl.scrollLeft || body.scrollLeft;

      var clientTop = docEl.clientTop || body.clientTop || 0;
      var clientLeft = docEl.clientLeft || body.clientLeft || 0;

      var top = box.top + scrollTop - clientTop;
      var left = box.left + scrollLeft - clientLeft;

      return { top: Math.round(top), left: Math.round(left) };
    },
    scrollToTargetAdjusted(refname) {
      let target;
      if (refname == "contact") {
        target = this.$refs.mobilemain.$refs.contact;
      } else if (refname == "how-to-join") {
        target = this.$refs.mobilemain.$refs.howtojoin;
      } else if (refname == "buyer-info") {
        target = this.$refs.mobilemain.$refs.buyerinfo;
      } else if (refname == "seller-info") {
        target = this.$refs.mobilemain.$refs.sellerinfo;
      } else {
        target = this.$refs.mobilemain.$refs.home;
      }

      var top = target.offsetTop - 100;
      window.scrollTo(0, top);
    },
  },
};
</script>
<style lang="scss" scoped>
#app {
  font-family: "MontserratRegular", sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  width: 100%;
}
body {
  height: 800px;
  margin: 0;
  width: 100%;
  margin: 0;
  padding: 0;
  min-width: 310px;
}
.wrapper {
  margin-top: 75px;
  width: 100%;
}
@font-face {
  font-family: "MontserratThin";
  src: url("/fonts/Montserrat/Montserrat-Thin.ttf");
}
@font-face {
  font-family: "MontserratLight";
  src: url("/fonts/Montserrat/Montserrat-Light.ttf");
}
@font-face {
  font-family: "MontserratRegular";
  src: url("/fonts/Montserrat/Montserrat-Regular.ttf");
}
@font-face {
  font-family: "MontserratMedium";
  src: url("/fonts/Montserrat/Montserrat-Medium.ttf");
}
@font-face {
  font-family: "MontserratSemiBold";
  src: url("/fonts/Montserrat/Montserrat-SemiBold.ttf");
}
@font-face {
  font-family: "MontserratBold";
  src: url("/fonts/Montserrat/Montserrat-Bold.ttf");
}
@font-face {
  font-family: "MontserratExtraBold";
  src: url("/fonts/Montserrat/Montserrat-ExtraBold.ttf");
}
</style>
